/*
 *   Copyright (c) 1988-1991 Shamus Software Ltd. 
 *
 * These routines use the datalink to swap a pair of strings 
 */

#include <stdio.h>
#include <gf.h>

extern int datalink(int,void(*)(),void(*)(),void(*)(),int(*)(),
                    void(*)(),int(*)(),void(*)());

static unsigned char *my_string,*her_string;
static int mylen,herlen;
static bool done,sent_my_string,got_her_string;

static void str_init()
{ /* initialise */
    done=FALSE;
    if (my_string!=NULL) sent_my_string=FALSE;
    else                 sent_my_string=TRUE;
    if (her_string!=NULL)got_her_string=FALSE;
    else                 got_her_string=TRUE;
}

static void str_ack()
{ /* respond to an ACK being received */
    sent_my_string=TRUE;
}

static void str_data(data,len)
char *data;
int len;
{ /* process received data */
    int i;
    for (i=0;i<len;i++)
    { /* extract data */
        her_string[i]=decode(data[i]);
    }
    got_her_string=TRUE;
    herlen=len;
}   

static int str_idle()
{ /* soft exit when finished */
    int ch;
    while (gfkbhit())
    { /* check keyboard */
        ch=getkey();
        if (ch==ESC) return 2;
    }
    if (sent_my_string && got_her_string) return 1;
    return 0;
}

static void str_stats(stat)
int stat;
{
}

static int str_ready(data,pig)
unsigned char *data;
int pig;
{
    int i;
    if (done) return 0;
    for (i=0;i<mylen;i++)
        data[i]=encode(my_string[i]);
    done=TRUE;
    return mylen;
}

static void str_end()
{
}

int exchange_strings(fcount,ml,mine,hl,hers)
int fcount,ml,*hl;
unsigned char *mine,*hers;
{
    int r;
    my_string=mine;
    mylen=ml;
    her_string=hers;
    r=datalink(fcount,str_init,str_ack,str_data,str_idle,
                    str_stats,str_ready,str_end);
    *hl=herlen;
    return r;
}

